diff --git a/src/detect-uricontent.c b/src/detect-uricontent.c
index 89d50e1..ac366e8 100644
--- a/src/detect-uricontent.c
+++ b/src/detect-uricontent.c
@@ -85,135 +85,6 @@ void PktHttpUriFree(Packet *p)
     p->http_uri.cnt = 0;
 }
 
-static inline int TestOffsetDepth(MpmMatch *m, DetectUricontentData *co)
-{
-    if (co->offset == 0 ||
-        (co->offset && ((m->offset+1) - co->uricontent_len) >= co->offset))
-    {
-        if (co->depth == 0 ||
-            (co->depth && (m->offset+1) <= co->depth))
-        {
-            return 1;
-        }
-    }
-
-    return 0;
-}
-
-/* This function is called recursively (if necessary) to be able
- * to determite whether or not a chain of content matches connected
- * with 'within' and 'distance' options fully matches. The reason it
- * was done like this is to make sure we can handle partial matches
- * that turn out to fail being followed by full matches later in the
- * packet. This adds some runtime complexity however. */
-static inline int TestWithinDistanceOffsetDepth(ThreadVars *t,
-                                                DetectEngineThreadCtx *det_ctx,
-                                                MpmMatch *m, SigMatch *nsm)
-{
-    //printf("test_nextsigmatch m:%p, nsm:%p\n", m,nsm);
-    if (nsm == NULL)
-        return 1;
-
-    DetectUricontentData *co = (DetectUricontentData *)nsm->ctx;
-    MpmMatch *nm = det_ctx->mtcu.match[co->id].top;
-
-    for (; nm; nm = nm->next) {
-        SCLogDebug("(nm->offset+1) %" PRIu32 ", (m->offset+1) %" PRIu32 "",
-                    (nm->offset+1), (m->offset+1));
-
-        if ((co->within == 0 || (co->within &&
-           ((nm->offset+1) > (m->offset+1)) &&
-           ((nm->offset+1) - (m->offset+1) <= co->within))))
-        {
-             SCLogDebug("WITHIN (nm->offset+1) %" PRIu32 ", (m->offset+1) "
-                        "%" PRIu32 "", (nm->offset+1), (m->offset+1));
-
-            if (co->distance == 0 || (co->distance &&
-               ((nm->offset+1) > (m->offset+1)) &&
-               ((nm->offset+1) - (m->offset+1) >= co->distance)))
-            {
-                if (TestOffsetDepth(nm, co) == 1) {
-                      SCLogDebug("DISTANCE (nm->offset+1) %" PRIu32 ", "
-                                 "(m->offset+1) %" PRIu32 "", (nm->offset+1),
-                                 (m->offset+1));
-                    return TestWithinDistanceOffsetDepth(t, det_ctx, nm,
-                                                         nsm->next);
-                }
-            }
-        }
-    }
-    return 0;
-}
-
-static inline int DoDetectUricontent(ThreadVars *t, DetectEngineThreadCtx *det_ctx,
-                                     Packet *p, SigMatch *sm,
-                                     DetectUricontentData *co)
-{
-    int ret = 0;
-    char match = 0;
-
-    /* Get the top match, we already know we have one. */
-    MpmMatch *m = det_ctx->mtcu.match[co->id].top;
-
-    /*  if we have within or distance coming up next, check this match
-     *  for distance and/or within and check the rest of this match
-     *  chain as well. */
-    if ((co->flags & DETECT_URICONTENT_WITHIN_NEXT ||
-         co->flags & DETECT_URICONTENT_DISTANCE_NEXT) &&
-         det_ctx->de_checking_distancewithin == 0)
-    {
-        /* indicate to the detection engine the next sigmatch(es)
-         * are part of this match chain */
-        det_ctx->de_checking_distancewithin = 1;
-
-        for (; m != NULL; m = m->next) {
-            /* first check our match for offset and depth */
-            if (TestOffsetDepth(m, co) == 1) {
-                ret = TestWithinDistanceOffsetDepth(t, det_ctx, m, sm->next);
-                if (ret == 1) {
-                    /* update pkt ptrs, content doesn't use this,
-                     * but pcre does */
-                    det_ctx->pkt_ptr = p->payload + m->offset;
-                    det_ctx->pkt_off = m->offset;
-                    match = 1;
-                    break;
-                }
-            }
-        }
-    /* Okay, this is complicated... on the first match of a match chain,
-     * we do the whole match of that chain (a chain here means a number
-     * of consecutive content matches that relate to each other with
-     * 'within and/or 'distance options'). But we still get to the next
-     * sigmatches. We have already inspected this sigmatch, even for
-     * offset and depth. Since the fact that we get there means we have
-     * had a match, we return match here too.
-     */
-    } else if (co->flags & DETECT_URICONTENT_WITHIN ||
-               co->flags & DETECT_URICONTENT_DISTANCE)
-    {
-        det_ctx->de_checking_distancewithin = 0;
-        match = 1;
-    /* Getting here means we are not in checking an within/distance chain.
-     * This means we can just inspect this content match on it's own. So
-     * Let's see if at least one of the matches within the offset and depth
-     * settings. If so, return a match.
-     */
-    } else {
-        for (; m != NULL; m = m->next) {
-            ret = TestOffsetDepth(m,co);
-            if (ret == 1) {
-                /* update pkt ptrs, content doesn't use this,
-                 * but pcre does */
-                det_ctx->pkt_ptr = p->payload + m->offset;
-                det_ctx->pkt_off = m->offset;
-                match = 1;
-                break;
-            }
-        }
-    }
-    return match;
-}
-
 
 /**
  * \brief   Checks if the packet sent as the argument, has a uricontent which
diff --git a/src/detect-uricontent.h b/src/detect-uricontent.h
index 063fd0a..67c117e 100644
--- a/src/detect-uricontent.h
+++ b/src/detect-uricontent.h
@@ -28,5 +28,137 @@ uint32_t DetectUricontentMaxId(DetectEngineCtx *);
 void PktHttpUriFree(Packet *p);
 uint32_t DetectUricontentInspectMpm(ThreadVars *th_v, DetectEngineThreadCtx *det_ctx, void *alstate);
 
+/** ------ inline functions ------ */
+
+static inline int TestOffsetDepthUri(MpmMatch *m, DetectUricontentData *co)
+{
+    if (co->offset == 0 ||
+        (co->offset && ((m->offset+1) - co->uricontent_len) >= co->offset))
+    {
+        if (co->depth == 0 ||
+            (co->depth && (m->offset+1) <= co->depth))
+        {
+            return 1;
+        }
+    }
+
+    return 0;
+}
+
+/* This function is called recursively (if necessary) to be able
+ * to determite whether or not a chain of content matches connected
+ * with 'within' and 'distance' options fully matches. The reason it
+ * was done like this is to make sure we can handle partial matches
+ * that turn out to fail being followed by full matches later in the
+ * packet. This adds some runtime complexity however. */
+static inline int TestWithinDistanceOffsetDepthUri(ThreadVars *t,
+                                                DetectEngineThreadCtx *det_ctx,
+                                                MpmMatch *m, SigMatch *nsm)
+{
+    //printf("test_nextsigmatch m:%p, nsm:%p\n", m,nsm);
+    if (nsm == NULL)
+        return 1;
+
+    DetectUricontentData *co = (DetectUricontentData *)nsm->ctx;
+    MpmMatch *nm = det_ctx->mtcu.match[co->id].top;
+
+    for (; nm; nm = nm->next) {
+        SCLogDebug("(nm->offset+1) %" PRIu32 ", (m->offset+1) %" PRIu32 "",
+                    (nm->offset+1), (m->offset+1));
+
+        if ((co->within == 0 || (co->within &&
+           ((nm->offset+1) > (m->offset+1)) &&
+           ((nm->offset+1) - (m->offset+1) <= co->within))))
+        {
+             SCLogDebug("WITHIN (nm->offset+1) %" PRIu32 ", (m->offset+1) "
+                        "%" PRIu32 "", (nm->offset+1), (m->offset+1));
+
+            if (co->distance == 0 || (co->distance &&
+               ((nm->offset+1) > (m->offset+1)) &&
+               ((nm->offset+1) - (m->offset+1) >= co->distance)))
+            {
+                if (TestOffsetDepthUri(nm, co) == 1) {
+                      SCLogDebug("DISTANCE (nm->offset+1) %" PRIu32 ", "
+                                 "(m->offset+1) %" PRIu32 "", (nm->offset+1),
+                                 (m->offset+1));
+                    return TestWithinDistanceOffsetDepthUri(t, det_ctx, nm,
+                                                         nsm->next);
+                }
+            }
+        }
+    }
+    return 0;
+}
+
+static inline int DoDetectUricontent(ThreadVars *t, DetectEngineThreadCtx *det_ctx,
+                                     Packet *p, SigMatch *sm,
+                                     DetectUricontentData *co)
+{
+    int ret = 0;
+    char match = 0;
+
+    /* Get the top match, we already know we have one. */
+    MpmMatch *m = det_ctx->mtcu.match[co->id].top;
+
+    /*  if we have within or distance coming up next, check this match
+     *  for distance and/or within and check the rest of this match
+     *  chain as well. */
+    if ((co->flags & DETECT_URICONTENT_WITHIN_NEXT ||
+         co->flags & DETECT_URICONTENT_DISTANCE_NEXT) &&
+         det_ctx->de_checking_distancewithin == 0)
+    {
+        /* indicate to the detection engine the next sigmatch(es)
+         * are part of this match chain */
+        det_ctx->de_checking_distancewithin = 1;
+
+        for (; m != NULL; m = m->next) {
+            /* first check our match for offset and depth */
+            if (TestOffsetDepthUri(m, co) == 1) {
+                ret = TestWithinDistanceOffsetDepthUri(t, det_ctx, m, sm->next);
+                if (ret == 1) {
+                    /* update pkt ptrs, content doesn't use this,
+                     * but pcre does */
+                    det_ctx->pkt_ptr = p->payload + m->offset;
+                    det_ctx->pkt_off = m->offset;
+                    match = 1;
+                    break;
+                }
+            }
+        }
+    /* Okay, this is complicated... on the first match of a match chain,
+     * we do the whole match of that chain (a chain here means a number
+     * of consecutive content matches that relate to each other with
+     * 'within and/or 'distance options'). But we still get to the next
+     * sigmatches. We have already inspected this sigmatch, even for
+     * offset and depth. Since the fact that we get there means we have
+     * had a match, we return match here too.
+     */
+    } else if (co->flags & DETECT_URICONTENT_WITHIN ||
+               co->flags & DETECT_URICONTENT_DISTANCE)
+    {
+        det_ctx->de_checking_distancewithin = 0;
+        match = 1;
+    /* Getting here means we are not in checking an within/distance chain.
+     * This means we can just inspect this content match on it's own. So
+     * Let's see if at least one of the matches within the offset and depth
+     * settings. If so, return a match.
+     */
+    } else {
+        for (; m != NULL; m = m->next) {
+            ret = TestOffsetDepthUri(m,co);
+            if (ret == 1) {
+                /* update pkt ptrs, content doesn't use this,
+                 * but pcre does */
+                det_ctx->pkt_ptr = p->payload + m->offset;
+                det_ctx->pkt_off = m->offset;
+                match = 1;
+                break;
+            }
+        }
+    }
+    return match;
+}
+
+
 #endif /* __DETECT_URICONTENT_H__ */
 
diff --git a/src/detect.c b/src/detect.c
index c4bb56b..8770174 100644
--- a/src/detect.c
+++ b/src/detect.c
@@ -433,60 +433,6 @@ int PacketAlertAppend(Packet *p, uint32_t gid, uint32_t sid, uint8_t rev,
     return 0;
 }
 
-inline SigGroupHead *SigMatchSignaturesGetSgh(ThreadVars *th_v, DetectEngineCtx *de_ctx, DetectEngineThreadCtx *det_ctx, Packet *p) {
-    SCEnter();
-
-    int ds,f;
-    SigGroupHead *sgh = NULL;
-
-    /* select the dsize_gh */
-    if (p->payload_len <= 100)
-        ds = 0;
-    else
-        ds = 1;
-
-    /* select the flow_gh */
-    if (p->flowflags & FLOW_PKT_TOCLIENT)
-        f = 0;
-    else
-        f = 1;
-
-    SCLogDebug("ds %d, f %d", ds, f);
-
-    /* find the right mpm instance */
-    DetectAddress *ag = DetectAddressLookupInHead(de_ctx->dsize_gh[ds].flow_gh[f].src_gh[p->proto],&p->src);
-    if (ag != NULL) {
-        /* source group found, lets try a dst group */
-        ag = DetectAddressLookupInHead(ag->dst_gh,&p->dst);
-        if (ag != NULL) {
-            if (ag->port == NULL) {
-                SCLogDebug("we don't have ports");
-                sgh = ag->sh;
-            } else {
-                SCLogDebug("we have ports");
-
-                DetectPort *sport = DetectPortLookupGroup(ag->port,p->sp);
-                if (sport != NULL) {
-                    DetectPort *dport = DetectPortLookupGroup(sport->dst_ph,p->dp);
-                    if (dport != NULL) {
-                        sgh = dport->sh;
-                    } else {
-                        SCLogDebug("no dst port group found for the packet");
-                    }
-                } else {
-                    SCLogDebug("no src port group found for the packet");
-                }
-            }
-        } else {
-            SCLogDebug("no dst address group found for the packet");
-        }
-    } else {
-        SCLogDebug("no src address group found for the packet");
-    }
-
-    SCReturnPtr(sgh, "SigGroupHead");
-}
-
 int SigMatchSignatures(ThreadVars *th_v, DetectEngineCtx *de_ctx, DetectEngineThreadCtx *det_ctx, Packet *p)
 {
     int match = 0, fmatch = 0;
diff --git a/src/detect.h b/src/detect.h
index 8de84a9..12d4099 100644
--- a/src/detect.h
+++ b/src/detect.h
@@ -5,8 +5,6 @@
 
 #include "flow.h"
 
-#include "detect-engine-proto.h"
-
 #include "packet-queue.h"
 #include "util-mpm.h"
 #include "util-hash.h"
@@ -21,6 +19,7 @@
 /* forward declarations for the structures from detect-engine-sigorder.h */
 struct SCSigOrderFunc_;
 struct SCSigSignatureWrapper_;
+typedef struct DetectEngineCtx_ DetectEngineCtx;
 
 /*
  * DETECT ADDRESS
@@ -46,6 +45,22 @@ enum {
 #define ADDRESS_PORTS_NOTUNIQ       0x10
 #define ADDRESS_HAVEPORT            0x20
 
+/*
+ * DETECT PORT
+ */
+
+/* a is ... than b */
+enum {
+    PORT_ER = -1, /* error e.g. compare ipv4 and ipv6 */
+    PORT_LT,      /* smaller              [aaa] [bbb] */
+    PORT_LE,      /* smaller with overlap [aa[bab]bb] */
+    PORT_EQ,      /* exactly equal        [abababab]  */
+    PORT_ES,      /* within               [bb[aaa]bb] and [[abab]bbb] and [bbb[abab]] */
+    PORT_EB,      /* completely overlaps  [aa[bbb]aa] and [[baba]aaa] and [aaa[baba]] */
+    PORT_GE,      /* bigger with overlap  [bb[aba]aa] */
+    PORT_GT,      /* bigger               [bbb] [aaa] */
+};
+
 typedef struct DetectAddress_ {
     /* address data for this group */
     uint8_t family;
@@ -68,28 +83,12 @@ typedef struct DetectAddress_ {
     uint32_t cnt;
 } DetectAddress;
 
-/** Signature grouping head. Here 'any', ipv4 and ipv6 are split out */
 typedef struct DetectAddressHead_ {
     DetectAddress *any_head;
     DetectAddress *ipv4_head;
     DetectAddress *ipv6_head;
 } DetectAddressHead;
 
-/*
- * DETECT PORT
- */
-
-/* a is ... than b */
-enum {
-    PORT_ER = -1, /* error e.g. compare ipv4 and ipv6 */
-    PORT_LT,      /* smaller              [aaa] [bbb] */
-    PORT_LE,      /* smaller with overlap [aa[bab]bb] */
-    PORT_EQ,      /* exactly equal        [abababab]  */
-    PORT_ES,      /* within               [bb[aaa]bb] and [[abab]bbb] and [bbb[abab]] */
-    PORT_EB,      /* completely overlaps  [aa[bbb]aa] and [[baba]aaa] and [aaa[baba]] */
-    PORT_GE,      /* bigger with overlap  [bb[aba]aa] */
-    PORT_GT,      /* bigger               [bbb] [aaa] */
-};
 
 #define PORT_FLAG_ANY           0x01 /**< 'any' special port */
 #define PORT_FLAG_NOT           0x02 /**< negated port */
@@ -117,6 +116,11 @@ typedef struct DetectPort_ {
     uint8_t flags;  /**< flags for this port */
 } DetectPort;
 
+#include "detect-engine-proto.h"
+#include "detect-engine-address.h"
+#include "detect-engine-port.h"
+
+
 /* Signature flags */
 #define SIG_FLAG_RECURSIVE 0x0001   /**< recursive capturing enabled */
 #define SIG_FLAG_SRC_ANY   0x0002   /**< source is any */
@@ -238,7 +242,7 @@ typedef struct ThresholdCtx_    {
 } ThresholdCtx;
 
 /** \brief main detection engine ctx */
-typedef struct DetectEngineCtx_ {
+struct DetectEngineCtx_ {
     uint8_t flags;
     uint8_t failure_fatal;
 
@@ -323,7 +327,7 @@ typedef struct DetectEngineCtx_ {
     uint16_t max_uniq_small_toserver_dst_groups;
     uint16_t max_uniq_small_toserver_sp_groups;
     uint16_t max_uniq_small_toserver_dp_groups;
-} DetectEngineCtx;
+};
 
 /* Engine groups profiles (low, medium, high, custom) */
 enum {
@@ -588,5 +592,61 @@ int SigMatchSignatures(ThreadVars *th_v, DetectEngineCtx *de_ctx,
                        DetectEngineThreadCtx *det_ctx, Packet *p);
 int SignatureIsIPOnly(DetectEngineCtx *de_ctx, Signature *s);
 
+/** ------ inline functions ------ */
+
+static inline SigGroupHead *SigMatchSignaturesGetSgh(ThreadVars *th_v, DetectEngineCtx *de_ctx, DetectEngineThreadCtx *det_ctx, Packet *p) {
+    SCEnter();
+
+    int ds,f;
+    SigGroupHead *sgh = NULL;
+
+    /* select the dsize_gh */
+    if (p->payload_len <= 100)
+        ds = 0;
+    else
+        ds = 1;
+
+    /* select the flow_gh */
+    if (p->flowflags & FLOW_PKT_TOCLIENT)
+        f = 0;
+    else
+        f = 1;
+
+    SCLogDebug("ds %d, f %d", ds, f);
+
+    /* find the right mpm instance */
+    DetectAddress *ag = DetectAddressLookupInHead(de_ctx->dsize_gh[ds].flow_gh[f].src_gh[p->proto],&p->src);
+    if (ag != NULL) {
+        /* source group found, lets try a dst group */
+        ag = DetectAddressLookupInHead(ag->dst_gh,&p->dst);
+        if (ag != NULL) {
+            if (ag->port == NULL) {
+                SCLogDebug("we don't have ports");
+                sgh = ag->sh;
+            } else {
+                SCLogDebug("we have ports");
+
+                DetectPort *sport = DetectPortLookupGroup(ag->port,p->sp);
+                if (sport != NULL) {
+                    DetectPort *dport = DetectPortLookupGroup(sport->dst_ph,p->dp);
+                    if (dport != NULL) {
+                        sgh = dport->sh;
+                    } else {
+                        SCLogDebug("no dst port group found for the packet");
+                    }
+                } else {
+                    SCLogDebug("no src port group found for the packet");
+                }
+            }
+        } else {
+            SCLogDebug("no dst address group found for the packet");
+        }
+    } else {
+        SCLogDebug("no src address group found for the packet");
+    }
+
+    SCReturnPtr(sgh, "SigGroupHead");
+}
+
 #endif /* __DETECT_H__ */
 
diff --git a/src/flow.c b/src/flow.c
index fcf90d9..9f2933c 100644
--- a/src/flow.c
+++ b/src/flow.c
@@ -327,42 +327,6 @@ void FlowDecrUsecnt(ThreadVars *tv, Packet *p) {
     SCMutexUnlock(&p->flow->m);
 }
 
-#define TOSERVER 0
-#define TOCLIENT 1
-
-/**
- *  \brief determine the direction of the packet compared to the flow
- *  \retval 0 to_server
- *  \retval 1 to_client
- */
-static inline int FlowGetPacketDirection(Flow *f, Packet *p) {
-    if (p->proto == IPPROTO_TCP || p->proto == IPPROTO_UDP) {
-        if (!(CMP_PORT(p->sp,p->dp))) {
-            /* update flags and counters */
-            if (CMP_PORT(f->sp,p->sp)) {
-                return TOSERVER;
-            } else {
-                return TOCLIENT;
-            }
-        } else {
-            if (CMP_ADDR(&f->src,&p->src)) {
-                return TOSERVER;
-            } else {
-                return TOCLIENT;
-            }
-        }
-    } else if (p->proto == IPPROTO_ICMP || p->proto == IPPROTO_ICMPV6) {
-        if (CMP_ADDR(&f->src,&p->src)) {
-            return TOSERVER;
-        } else {
-            return TOCLIENT;
-        }
-    }
-
-    /* default to toserver */
-    return TOSERVER;
-}
-
 /** \brief Entry point for packet flow handling
  *
  * This is called for every packet.
diff --git a/src/flow.h b/src/flow.h
index 842e8d7..4953484 100644
--- a/src/flow.h
+++ b/src/flow.h
@@ -137,5 +137,43 @@ void FlowSetNoPacketInspectionFlag(Flow *);
 void FlowLockSetNoPayloadInspectionFlag(Flow *);
 void FlowSetNoPayloadInspectionFlag(Flow *);
 
+/** ------ inline functions ------ */
+
+#define TOSERVER 0
+#define TOCLIENT 1
+
+/**
+ *  \brief determine the direction of the packet compared to the flow
+ *  \retval 0 to_server
+ *  \retval 1 to_client
+ */
+static inline int FlowGetPacketDirection(Flow *f, Packet *p) {
+    if (p->proto == IPPROTO_TCP || p->proto == IPPROTO_UDP) {
+        if (!(CMP_PORT(p->sp,p->dp))) {
+            /* update flags and counters */
+            if (CMP_PORT(f->sp,p->sp)) {
+                return TOSERVER;
+            } else {
+                return TOCLIENT;
+            }
+        } else {
+            if (CMP_ADDR(&f->src,&p->src)) {
+                return TOSERVER;
+            } else {
+                return TOCLIENT;
+            }
+        }
+    } else if (p->proto == IPPROTO_ICMP || p->proto == IPPROTO_ICMPV6) {
+        if (CMP_ADDR(&f->src,&p->src)) {
+            return TOSERVER;
+        } else {
+            return TOCLIENT;
+        }
+    }
+
+    /* default to toserver */
+    return TOSERVER;
+}
+
 #endif /* __FLOW_H__ */
 
diff --git a/src/stream-tcp.c b/src/stream-tcp.c
index 8ba3e5d..7854f96 100644
--- a/src/stream-tcp.c
+++ b/src/stream-tcp.c
@@ -382,39 +382,6 @@ TcpSession *StreamTcpNewSession (Packet *p)
     return ssn;
 }
 
-static inline void StreamTcpPacketSetState(Packet *p, TcpSession *ssn,
-                                           uint8_t state)
-{
-    if (state == ssn->state)
-        return;
-
-    ssn->state = state;
-
-    FlowUpdateQueue(p->flow);
-}
-
-/**
- *  \brief  Function to flip the direction When we missed the SYN packet,
- *          SYN/ACK is considered as sent by server, but our engine flagged the
- *          packet as from client for the host whose packet is received first in
- *          the session.
- *
- *  \param  ssn TcpSession to whom this packet belongs
- *  \param  p   Packet whose flag has to be changed
- */
-static inline void StreamTcpPacketSwitchDir(TcpSession *ssn, Packet *p)
-{
-    SCLogDebug("ssn %p: switching pkt direction", ssn);
-
-    if (PKT_IS_TOSERVER(p)) {
-        p->flowflags &= ~FLOW_PKT_TOSERVER;
-        p->flowflags |= FLOW_PKT_TOCLIENT;
-    } else {
-        p->flowflags &= ~FLOW_PKT_TOCLIENT;
-        p->flowflags |= FLOW_PKT_TOSERVER;
-    }
-}
-
 /**
  *  \brief  Function to set the OS policy for the given stream based on the
  *          destination of the received packet.
diff --git a/src/stream-tcp.h b/src/stream-tcp.h
index f817038..ca666eb 100644
--- a/src/stream-tcp.h
+++ b/src/stream-tcp.h
@@ -3,6 +3,11 @@
 #ifndef __STREAM_TCP_H__
 #define __STREAM_TCP_H__
 
+#include "stream-tcp-private.h"
+#include "stream-tcp-reassemble.h"
+#include "stream-tcp.h"
+#include "stream.h"
+
 #define COUNTER_STREAMTCP_STREAMS 1
 
 #define STREAM_VERBOSE    FALSE
@@ -25,5 +30,42 @@ void StreamTcpIncrMemuse(uint32_t);
 void StreamTcpDecrMemuse(uint32_t);
 int StreamTcpCheckMemcap(uint32_t);
 
+/** ------ inline functions ------ */
+
+static inline void StreamTcpPacketSetState(Packet *p, TcpSession *ssn,
+                                           uint8_t state)
+{
+    if (state == ssn->state)
+        return;
+
+    ssn->state = state;
+
+    FlowUpdateQueue(p->flow);
+}
+
+/**
+ *  \brief  Function to flip the direction When we missed the SYN packet,
+ *          SYN/ACK is considered as sent by server, but our engine flagged the
+ *          packet as from client for the host whose packet is received first in
+ *          the session.
+ *
+ *  \param  ssn TcpSession to whom this packet belongs
+ *  \param  p   Packet whose flag has to be changed
+ */
+static inline void StreamTcpPacketSwitchDir(TcpSession *ssn, Packet *p)
+{
+    SCLogDebug("ssn %p: switching pkt direction", ssn);
+
+    if (PKT_IS_TOSERVER(p)) {
+        p->flowflags &= ~FLOW_PKT_TOSERVER;
+        p->flowflags |= FLOW_PKT_TOCLIENT;
+    } else {
+        p->flowflags &= ~FLOW_PKT_TOCLIENT;
+        p->flowflags |= FLOW_PKT_TOSERVER;
+    }
+}
+
+
+
 #endif /* __STREAM_TCP_H__ */
 
diff --git a/src/suricata-common.h b/src/suricata-common.h
index 278a928..0171468 100644
--- a/src/suricata-common.h
+++ b/src/suricata-common.h
@@ -118,5 +118,36 @@
 size_t strlcat(char *, const char *src, size_t siz);
 size_t strlcpy(char *dst, const char *src, size_t siz);
 
+/* uppercase to lowercase conversion lookup table */
+uint8_t g_u8_lowercasetable[256];
+/* marco to do the actual lookup */
+#define u8_tolower(c) g_u8_lowercasetable[(c)]
+
+/** ---- Inline functions ---- */
+static inline void memcpy_tolower(uint8_t *d, uint8_t *s, uint16_t len)
+{
+    uint16_t i;
+    for (i = 0; i < len; i++)
+        d[i] = u8_tolower(s[i]);
+
+    return;
+}
+
+static inline int
+memcmp_lowercase(uint8_t *s1, uint8_t *s2, uint16_t n) {
+    size_t i;
+
+    /* check backwards because we already tested the first
+     * 2 to 4 chars. This way we are more likely to detect
+     * a miss and thus speed up a little... */
+    for (i = n - 1; i; i--) {
+        if (u8_tolower(*(s2+i)) != s1[i])
+            return 1;
+    }
+
+    return 0;
+}
+
+
 #endif /* __SURICATA_COMMON_H__ */
 
diff --git a/src/suricata.h b/src/suricata.h
index 4426786..abb549b 100644
--- a/src/suricata.h
+++ b/src/suricata.h
@@ -52,10 +52,6 @@ PacketQueue trans_q[256];
 /* memset to zeros, and mutex init! */
 void GlobalInits();
 
-/* uppercase to lowercase conversion lookup table */
-uint8_t g_u8_lowercasetable[256];
-/* marco to do the actual lookup */
-#define u8_tolower(c) g_u8_lowercasetable[(c)]
 // these 2 are slower:
 //#define u8_tolower(c) ((c) >= 'A' && (c) <= 'Z') ? g_u8_lowercasetable[(c)] : (c)
 //#define u8_tolower(c) ((c) >= 'A' && (c) <= 'Z') ? ((c) + ('a' - 'A')) : (c)
diff --git a/src/tm-threads.c b/src/tm-threads.c
index f4233c0..926623b 100644
--- a/src/tm-threads.c
+++ b/src/tm-threads.c
@@ -47,68 +47,6 @@ SCMutex tv_root_lock = PTHREAD_MUTEX_INITIALIZER;
    thread encounters a failure.  Defaults to restart the failed thread */
 uint8_t tv_aof = THV_RESTART_THREAD;
 
-typedef struct TmSlot_ {
-    /* function pointers */
-    TmEcode (*SlotFunc)(ThreadVars *, Packet *, void *, PacketQueue *);
-
-    TmEcode (*SlotThreadInit)(ThreadVars *, void *, void **);
-    void (*SlotThreadExitPrintStats)(ThreadVars *, void *);
-    TmEcode (*SlotThreadDeinit)(ThreadVars *, void *);
-
-    /* data storage */
-    void *slot_initdata;
-    void *slot_data;
-    PacketQueue slot_pq;
-
-    /* linked list, only used by TmVarSlot */
-    struct TmSlot_ *slot_next;
-} TmSlot;
-
-/* 1 function slot */
-typedef struct Tm1Slot_ {
-    TmSlot s;
-} Tm1Slot;
-
-/* Variable number of function slots */
-typedef struct TmVarSlot_ {
-    TmSlot *s;
-} TmVarSlot;
-
-/** \retval 1 flag is set
- *  \retval 0 flag is not set
- */
-inline int TmThreadsCheckFlag(ThreadVars *tv, uint8_t flag) {
-    int r;
-    if (SCSpinLock(&tv->flags_spinlock) != 0) {
-        SCLogError(SC_ERR_SPINLOCK,"spin lock errno=%d",errno);
-        return 0;
-    }
-
-    r = (tv->flags & flag);
-   SCSpinUnlock(&tv->flags_spinlock);
-    return r;
-}
-
-inline void TmThreadsSetFlag(ThreadVars *tv, uint8_t flag) {
-    if (SCSpinLock(&tv->flags_spinlock) != 0) {
-        SCLogError(SC_ERR_SPINLOCK,"spin lock errno=%d",errno);
-        return;
-    }
-
-    tv->flags |= flag;
-   SCSpinUnlock(&tv->flags_spinlock);
-}
-
-inline void TmThreadsUnsetFlag(ThreadVars *tv, uint8_t flag) {
-    if (SCSpinLock(&tv->flags_spinlock) != 0) {
-        SCLogError(SC_ERR_SPINLOCK,"spin lock errno=%d",errno);
-        return;
-    }
-
-    tv->flags &= ~flag;
-   SCSpinUnlock(&tv->flags_spinlock);
-}
-
 /* 1 slot functions */
 
 void *TmThreadsSlot1NoIn(void *td) {
@@ -371,44 +309,6 @@ void *TmThreadsSlot1(void *td) {
     pthread_exit((void *) 0);
 }
 
-/* separate run function so we can call it recursively */
-static inline TmEcode TmThreadsSlotVarRun (ThreadVars *tv, Packet *p, TmSlot *slot) {
-    TmEcode r = TM_ECODE_OK;
-    TmSlot *s = NULL;
-
-    for (s = slot; s != NULL; s = s->slot_next) {
-        r = s->SlotFunc(tv, p, s->slot_data, &s->slot_pq);
-        /* handle error */
-        if (r == TM_ECODE_FAILED) {
-            /* Encountered error.  Return packets to packetpool and return */
-            TmqhReleasePacketsToPacketPool(&s->slot_pq);
-            TmThreadsSetFlag(tv, THV_FAILED);
-            return TM_ECODE_FAILED;
-        }
-
-        /* handle new packets */
-        while (s->slot_pq.len > 0) {
-            Packet *extra_p = PacketDequeue(&s->slot_pq);
-
-            /* see if we need to process the packet */
-            if (s->slot_next != NULL) {
-                r = TmThreadsSlotVarRun(tv, extra_p, s->slot_next);
-                /* XXX handle error */
-                if (r == TM_ECODE_FAILED) {
-                    //printf("TmThreadsSlotVarRun: recursive TmThreadsSlotVarRun returned 1\n");
-                    TmqhReleasePacketsToPacketPool(&s->slot_pq);
-                    TmqhOutputPacketpool(tv, extra_p);
-                    TmThreadsSetFlag(tv, THV_FAILED);
-                    return TM_ECODE_FAILED;
-                }
-            }
-            tv->tmqh_out(tv, extra_p);
-        }
-    }
-
-    return TM_ECODE_OK;
-}
-
 void *TmThreadsSlotVar(void *td) {
     ThreadVars *tv = (ThreadVars *)td;
     TmVarSlot *s = (TmVarSlot *)tv->tm_slots;
